diff --git a/corefreq-api.h b/corefreq-api.h
index 9aa38273..1e3f3564 100644
--- a/corefreq-api.h
+++ b/corefreq-api.h
@@ -368,8 +368,10 @@ typedef struct
 	/* 40Ch */		P945_MC_DRAM_RANK_WIDTH WIDTH;	/* 16 bits */
 			} P945;
 			struct {
+	/* 100h */		P945_MC_DRAM_RANK_BOUND DRB[4]; /* 4x8 bits*/
 	/* 114h */		P955_MC_DRAM_TIMING_R1	DRT1;	/* 32 bits */
 	/* 10Eh */		P945_MC_DRAM_BANK_ARCH	BANK;	/* 16 bits */
+	/* 40Ch */		P945_MC_DRAM_RANK_WIDTH WIDTH;	/* 16 bits */
 			} P955;
 			struct {
 	/* 29Ch */		P965_MC_ODTCTRL		DRT0;	/* 32 bits */
@@ -435,6 +437,9 @@ typedef struct
 	/* 200h */	P945_MC_DCC		DCC;		/* 32 bits */
 		} P945;
 		struct {
+	/* 200h */	P945_MC_DCC		DCC;		/* 32 bits */
+		} P955;
+		struct {
 	/* 260h */	P965_MC_CKECTRL		CKE0,		/* 32 bits */
 						CKE1;		/* 32 bits */
 		} P965;
diff --git a/corefreqd.c b/corefreqd.c
index 6fa59509..31ef7aa9 100644
--- a/corefreqd.c
+++ b/corefreqd.c
@@ -552,12 +552,13 @@ void P945_MCH(SHM_STRUCT *Shm, PROC *Proc)
     unsigned short mc, cha, slot;
 
     Shm->Uncore.CtrlCount = Proc->Uncore.CtrlCount;
-    for (mc = 0; mc < Shm->Uncore.CtrlCount; mc++) {
-
+    for (mc = 0; mc < Shm->Uncore.CtrlCount; mc++)
+    {
       Shm->Uncore.MC[mc].SlotCount = Proc->Uncore.MC[mc].SlotCount;
       Shm->Uncore.MC[mc].ChannelCount = Proc->Uncore.MC[mc].ChannelCount;
 
-      for (cha = 0; cha < Shm->Uncore.MC[mc].ChannelCount; cha++) {
+      for (cha = 0; cha < Shm->Uncore.MC[mc].ChannelCount; cha++)
+      {
 	Shm->Uncore.MC[mc].Channel[cha].Timing.tWR =
 			Proc->Uncore.MC[mc].Channel[cha].P945.DRT0.tWR;
 
@@ -600,40 +601,40 @@ void P945_MCH(SHM_STRUCT *Shm, PROC *Proc)
 	Shm->Uncore.MC[mc].Channel[cha].Timing.tRP =
 			Proc->Uncore.MC[mc].Channel[cha].P945.DRT1.tRP + 2;
 
-       for (slot = 0; slot < Shm->Uncore.MC[mc].SlotCount; slot++)
-       {
-	unsigned short rank, rankCount = (cha == 0) ? 4 : 2;
-	for (rank = 0; rank < rankCount; rank++)
-	    Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Ranks +=
-		Proc->Uncore.MC[mc].Channel[cha].P945.DRB[rank].Boundary;
-
-	switch(Proc->Uncore.MC[mc].Channel[cha].P945.BANK.Rank0)
+	for (slot = 0; slot < Shm->Uncore.MC[mc].SlotCount; slot++)
 	{
+	    unsigned short rank, rankCount = (cha == 0) ? 4 : 2;
+	    for (rank = 0; rank < rankCount; rank++) {
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Ranks +=
+		    Proc->Uncore.MC[mc].Channel[cha].P945.DRB[rank].Boundary;
+	    }
+	    switch(Proc->Uncore.MC[mc].Channel[cha].P945.BANK.Rank0)
+	    {
 	    case 0b00:
 		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks = 4;
 		break;
 	    case 0b01:
 		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks = 8;
 		break;
-	}
-	switch(Proc->Uncore.MC[mc].Channel[cha].P945.WIDTH.Rank0)
-	{
+	    }
+	    switch(Proc->Uncore.MC[mc].Channel[cha].P945.WIDTH.Rank0)
+	    {
 	    case 0b00:
 		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows = 16384;
 		break;
 	    case 0b01:
 		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows = 8192;
 		break;
-	}
-	Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols = 1024;
+	    }
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols = 1024;
 
-	Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size =
-		  Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows
-		* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols
-		* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks
-		* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Ranks;
-	Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size /= (1024 * 1024);
-       }
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size =
+			  Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows
+			* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols
+			* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks
+			* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Ranks;
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size /=(1024 * 1024);
+	}
 	Shm->Uncore.MC[mc].Channel[cha].Timing.ECC = 0;
       }
     }
@@ -644,12 +645,13 @@ void P955_MCH(SHM_STRUCT *Shm, PROC *Proc)
     unsigned short mc, cha, slot;
 
     Shm->Uncore.CtrlCount = Proc->Uncore.CtrlCount;
-    for (mc = 0; mc < Shm->Uncore.CtrlCount; mc++) {
-
+    for (mc = 0; mc < Shm->Uncore.CtrlCount; mc++)
+    {
       Shm->Uncore.MC[mc].SlotCount = Proc->Uncore.MC[mc].SlotCount;
       Shm->Uncore.MC[mc].ChannelCount = Proc->Uncore.MC[mc].ChannelCount;
 
-      for (cha = 0; cha < Shm->Uncore.MC[mc].ChannelCount; cha++) {
+      for (cha = 0; cha < Shm->Uncore.MC[mc].ChannelCount; cha++)
+      {
 	Shm->Uncore.MC[mc].Channel[cha].Timing.tRAS =
 			Proc->Uncore.MC[mc].Channel[cha].P955.DRT1.tRAS;
 
@@ -674,7 +676,38 @@ void P955_MCH(SHM_STRUCT *Shm, PROC *Proc)
 	Shm->Uncore.MC[mc].Channel[cha].Timing.tRP =
 			Proc->Uncore.MC[mc].Channel[cha].P955.DRT1.tRP + 2;
 
-	for (slot = 0; slot < Shm->Uncore.MC[mc].SlotCount; slot++) {
+	for (slot = 0; slot < Shm->Uncore.MC[mc].SlotCount; slot++)
+	{
+	    unsigned short rank;
+	    for (rank = 0; rank < 4; rank++) {
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Ranks +=
+		    Proc->Uncore.MC[mc].Channel[cha].P955.DRB[rank].Boundary;
+	    }
+	    switch(Proc->Uncore.MC[mc].Channel[cha].P955.BANK.Rank0)
+	    {
+	    case 0b00:
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks = 4;
+		break;
+	    case 0b01:
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks = 8;
+		break;
+	    }
+	    switch(Proc->Uncore.MC[mc].Channel[cha].P955.WIDTH.Rank0)
+	    {
+	    case 0b00:
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows = 16384;
+		break;
+	    case 0b01:
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows = 8192;
+		break;
+	    }
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols = 1024;
+
+		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size =
+			  Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Rows
+			* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Cols
+			* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Banks
+			* Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Ranks;
 		Shm->Uncore.MC[mc].Channel[cha].DIMM[slot].Size = 0;
 	}
 	Shm->Uncore.MC[mc].Channel[cha].Timing.ECC = 0;
diff --git a/corefreqk.c b/corefreqk.c
index c5ab55eb..52c5b192 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -1642,7 +1642,8 @@ void Query_P945(void __iomem *mchmap)
 
 	Proc->Uncore.MC[0].SlotCount = 1;
 
-	for (cha = 0; cha < Proc->Uncore.MC[0].ChannelCount; cha++) {
+	for (cha = 0; cha < Proc->Uncore.MC[0].ChannelCount; cha++)
+	{
 		unsigned short rank, rankCount;
 
 		Proc->Uncore.MC[0].Channel[cha].P945.DRT0.value =
@@ -1680,9 +1681,9 @@ void Query_P955(void __iomem *mchmap)
 
 	Proc->Uncore.Bus.ClkCfg.value = readl(mchmap + 0xc00);
 
-	Proc->Uncore.MC[0].P945.DCC.value = readl(mchmap + 0x200);
+	Proc->Uncore.MC[0].P955.DCC.value = readl(mchmap + 0x200);
 
-	switch (Proc->Uncore.MC[0].P945.DCC.DAMC) {
+	switch (Proc->Uncore.MC[0].P955.DCC.DAMC) {
 	case 0b00:
 	case 0b11:
 		Proc->Uncore.MC[0].ChannelCount = 1;
@@ -1695,17 +1696,22 @@ void Query_P955(void __iomem *mchmap)
 
 	Proc->Uncore.MC[0].SlotCount = 1;
 
-	for (cha = 0; cha < Proc->Uncore.MC[0].ChannelCount; cha++) {
+	for (cha = 0; cha < Proc->Uncore.MC[0].ChannelCount; cha++)
+	{
 		unsigned short rank;
-		for (rank = 0; rank < 4; rank++)
-			Proc->Uncore.MC[0].Channel[cha].P945.DRB[rank].value =
-				readw(mchmap + 0x100 + rank + 0x80 * cha);
 
 		Proc->Uncore.MC[0].Channel[cha].P955.DRT1.value =
 					readw(mchmap + 0x114 + 0x80 * cha);
 
 		Proc->Uncore.MC[0].Channel[cha].P955.BANK.value =
 					readw(mchmap + 0x10e + 0x80 * cha);
+
+		Proc->Uncore.MC[0].Channel[cha].P955.WIDTH.value =
+					readw(mchmap + 0x40c + 0x80 * cha);
+
+	    for (rank = 0; rank < 4; rank++)
+		Proc->Uncore.MC[0].Channel[cha].P955.DRB[rank].value =
+				readb(mchmap + 0x100 + rank + 0x80 * cha);
 	}
 }
 
diff --git a/coretypes.h b/coretypes.h
index 17be0f2b..4442b6d3 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.23.2"
+#define COREFREQ_VERSION	"1.23.3"
 
 enum {	GenuineIntel,		\
 	Core_Yonah,		\
